import { Block } from '@ensi-platform/core-components';
import { createColumnHelper } from '@tanstack/react-table';
import { useRouter } from 'next/router';
import { useCallback, useMemo } from 'react';

import { Stock, useSearchStocks, useStocksMeta } from '@api/catalog';

import { useError } from '@context/modal';

import LoadingSkeleton from '@controls/LoadingSkeleton';

import Table, { TooltipItem, TrProps, useSorting, useTable } from '@components//Table';
import AutoFilters from '@components/AutoFilters';
import { RowTooltipWrapper, TableEmpty, TableFooter } from '@components/Table/components';

import { ActionType } from '@scripts/enums';
import { Button, Layout, scale, typography } from '@scripts/gds';
import { declOfNum, getPagination, getTotal, getTotalPages, parseBackendSort } from '@scripts/helpers';
import { usePopupState, useRedirectToNotEmptyPage, useTableList } from '@scripts/hooks';
import { useAutoColumns, useAutoFilters, useAutoTableData } from '@scripts/hooks/autoTable';

import EditIcon from '@icons/small/edit.svg';

import { useOffersAccess } from '../useOffersAccess';
import { EditStockPopup, EditStockPopupState } from './EditStockPopup';

const columnHelper = createColumnHelper<Stock>();

export const StocksTable = ({ offerId }: { offerId: number }) => {
    const { pathname, push, query } = useRouter();
    const access = useOffersAccess();

    const disabled = !access.ID.stocks.edit;

    const { data: metaData, error: metaError } = useStocksMeta(access.LIST.view);
    const meta = metaData?.data;
    useError(metaError);

    const {
        codesToSortKeys,
        metaField,
        values,
        filtersActive,
        URLHelper,
        searchRequestFilter,
        emptyInitialValues,
        reset,
        clearInitialValue,
    } = useAutoFilters(meta);

    const { itemsPerPageCount, setItemsPerPageCount, activePage } = useTableList({
        defaultPerPage: 10,
        codesToSortKeys,
    });

    const initialSort = useMemo(() => parseBackendSort(meta?.default_sort), [meta?.default_sort]);
    const [{ backendSorting }, sortingPlugin] = useSorting<Stock>('offer_stocks', meta?.fields, initialSort);

    const { data, isFetched, error } = useSearchStocks(
        {
            sort: backendSorting,
            filter: {
                offer_id: offerId,
                ...searchRequestFilter,
            },
            pagination: getPagination(activePage, itemsPerPageCount),
        },
        !Number.isNaN(+offerId) && !!backendSorting
    );
    useError(error);

    const [stockState, stockDispatch] = usePopupState<Partial<EditStockPopupState>>({ open: false });

    const stocks = useAutoTableData<Stock>(data?.data, metaField);
    const autoGeneratedColumns = useAutoColumns(meta);

    const columns = useMemo(
        () => [
            ...autoGeneratedColumns,
            columnHelper.display({
                id: 'settings',
                header: '',
                // eslint-disable-next-line react/no-unstable-nested-components
                cell: ({ row: { original } }) => (
                    <Layout type="flex">
                        <Layout.Item>
                            <Button
                                hidden
                                disabled={disabled}
                                Icon={EditIcon}
                                onClick={() => {
                                    stockDispatch({
                                        type: ActionType.Edit,
                                        payload: {
                                            data: {
                                                qty: original.qty,
                                                stock_id: original.id,
                                                store_id: original.store_id,
                                            },
                                            open: true,
                                        },
                                    });
                                }}
                            >
                                изменить
                            </Button>
                        </Layout.Item>
                    </Layout>
                ),
            }),
        ],
        [autoGeneratedColumns, disabled, stockDispatch]
    );

    const table = useTable(
        {
            data: stocks,
            columns,
            meta: {
                tableKey: `seller_stores`,
            },
        },
        [sortingPlugin]
    );

    const total = getTotal(data);
    const totalPages = getTotalPages(data, itemsPerPageCount);
    useRedirectToNotEmptyPage({ activePage, itemsPerPageCount, total });

    const tooltipItems = useMemo(
        (): TooltipItem[] => [
            {
                text: 'Редактировать',
                type: 'edit',
                action(row) {
                    if (!row) return;
                    const storeId =
                        typeof row[0].original.store_id === 'number'
                            ? row[0].original.store_id
                            : row[0].original.store_id_original.id;
                    stockDispatch({
                        type: ActionType.Edit,
                        payload: {
                            data: {
                                store_id: storeId,
                                stock_id: row[0].original.id,
                                qty: row[0].original.qty || 0,
                            },
                            open: true,
                        },
                    });
                },
                isDisable: true,
            },
        ],
        [disabled, stockDispatch]
    );

    const getTooltipForRow = useCallback(() => tooltipItems, [tooltipItems]);

    const renderRow = useCallback(
        ({ children, ...props }: TrProps<any>) => (
            <RowTooltipWrapper
                {...props}
                getTooltipForRow={getTooltipForRow}
                onDoubleClick={() => {
                    push(`${pathname}/${props.row?.original[meta?.detail_link || 'id']}`);
                }}
            >
                {children}
            </RowTooltipWrapper>
        ),
        [getTooltipForRow, meta?.detail_link, pathname, push]
    );

    return (
        <>
            <AutoFilters
                initialValues={values}
                emptyInitialValues={emptyInitialValues}
                onSubmit={vals => {
                    URLHelper(vals, true);
                }}
                queryPart={{ tab: query.tab }}
                filtersActive={filtersActive}
                css={{ marginBottom: scale(2) }}
                meta={meta}
                onResetFilters={reset}
                clearInitialValue={clearInitialValue}
            />
            <Block css={{ marginBottom: scale(3) }}>
                <Block.Body>
                    <Layout type="flex" justify="space-between" css={{ marginBottom: `${scale(2)}px !important` }}>
                        <Layout.Item>
                            <p css={{ lineHeight: '32px', ...typography('bodySm') }}>
                                <p>Найдено {`${total} ${declOfNum(total, ['сток', 'стока', 'стоков'])}`}</p>
                            </p>
                        </Layout.Item>
                    </Layout>

                    {!isFetched ? (
                        <LoadingSkeleton height={scale(25)} css={{ width: '100%' }} />
                    ) : (
                        <Table instance={table} Tr={renderRow} />
                    )}

                    {stocks.length === 0 && isFetched ? (
                        <TableEmpty
                            filtersActive={filtersActive}
                            titleWithFilters="Стоки не найдены"
                            titleWithoutFilters="Стоков нет"
                            onResetFilters={reset}
                        />
                    ) : (
                        <TableFooter
                            pages={totalPages}
                            itemsPerPageCount={itemsPerPageCount}
                            setItemsPerPageCount={setItemsPerPageCount}
                        />
                    )}
                </Block.Body>
            </Block>
            <EditStockPopup state={stockState} dispatch={stockDispatch} />
        </>
    );
};

export default StocksTable;
